/*	autor: Kacper Szkudlarek
 *	grupa: 4I2 */

#include <iostream>
#include <list>
#include <string>

using namespace std;

class Testowa{
private:
	int x_;
	string tekst_;
public:
	Testowa():x_(0), tekst_(""){}
	Testowa(int x, string& tekst): x_(x), tekst_(tekst){}
	friend ostream& operator<< (ostream& str, const Testowa& test);
	friend bool operator<(const Testowa& t1, const Testowa& t2);
};

bool operator <(const Testowa& t1, const Testowa& t2){
	return t1.x_ < t2.x_;
}

ostream& operator<< (ostream& str,const Testowa& test){
		str << test.x_ << " " << test.tekst_ << endl;
		return str;
}

bool singleDigit(const int& val){
	return val < 10;
}

template<class T> void wypiszListe(list<T> &li, const char* tekst){
	list<T>::const_iterator iter;
	cout << "------------------------------------------------------------------" << endl;
	cout << tekst << endl;
	cout << "------------------------------------------------------------------" << endl;
	for(iter = li.begin(); iter != li.end(); ++iter){
		 cout << *iter << endl;
	} 
}


int main(int argc, char** argv){
	cout << "****************************************************" << endl;
	cout << "*  Przykad operaji na liscie typu wbudowanego int *" << endl;
	cout << "****************************************************" << endl << endl << endl;

/*	Nagwek <list> zawiera deklakracj std::list. Naszym pierwszym krokiem bdzie utworzenie pustej listy typu int i nazwanie jej li: */
	 list <int> li;

/*	Aby umieci na kocu listy pojedynczy element, uywamy funkcji: */

	li.push_back(1);

/*	Aby usun pojedynczy element z koca listy, uywam funkcji: */

	li.pop_back();

/*	Przecieiwestwem do push_back(),  jets funkcja push_front() umieszcajca pojedynczy element na pocztku listy: */

	li.push_front(0); // Teraz pierwszym elementem jest 0, a nie 1

/*	Podobnie, pop_front() usuwa pierwszy element listy: */

	li.pop_front();

/*	Aby usun element z listy, nie znaj jego konkretnego pooenia, uywamy remove(). 
 *	remove(n) usunie wszystkie elementy rwne n, znajdujce sie na lisie:*/
	li.remove(0); // li nie zawiera wiecej elementw  

/*	Moliwe jest take usuwanie warunkowe, element, jest usuwany z listy. Instrukcj warunkow, moze byc dowolne wyraenie
 *	pobierajce element taki jak typ listy i zwracajce wartosc bool*/
	li.remove_if(singleDigit);

/*	Jeeli chcemy, aby lista bya "rnowartosciowa" mona zastosowa metod unique(). Ma ona dwie przecizone wersje,
 *	bezparametrow, dokonujac zwykgo porwnania elementw, i wersje, w ktrej mozemy zdefiniowa metod porwnujac.
 *	Naly jednak pamieta, ze funkcja ta usunie element, tylki i wyacznie, jeeli bdzie on rwny elementowi go poprzedajcemu.*/

/*	std::list pozwala take na operacje na wielu elementach, dziki czemu, mozemy postortowa,
 *	czy wypeni list seri od razu.
 *	
 *	Iteratory:
 *	Funkcje begin()i end()zwracajc iteratory wskazujace odpowiednio na pierwszy i osttatni element listy.
 *	Mona ich uy do dostpu sekwenyjnego do listy:*/
	list<int>::const_iterator iter;
	for(iter = li.begin(); iter != li.end(); ++iter){
	 cout << *iter << endl;
	} 
/*	Funkcje rbegin() i rend() zwracaj std::list::reverse_iterator pozwalajc na przechodzenie listy
 *	w kolejnoci odwrotnej, zwarcajc odpowiednio elelemtn ostatni i perwszy.*/

/*	Funkcja assign() wypenia list seri/sekwencj danych z innej listy, vecotra, tablicy. 
 *	Pobiera dwa iteratory wskazujce pocztek i koniec serii danych:*/
	int tab[3] = {10,40,30};
	li.assign( &tab[0], &tab[3]);
	wypiszListe(li, "Lista wypelniona za pomoca assign");
	
/*	W celu wstawienia elelemntw do listy, mona take uy metody insert().
 *	Przyjmuje ona jako paramatry, element, przed ktrym maja by wstawione elementy, a takze element, lub grupe iteratory na pocztek i koniec grupy element do wstawienia.*/

	iter = li.begin();
	++iter; ++iter;
	int tabIns[2] = {5, 6};
	li.insert(iter, &tabIns[0], &tabIns[2]);
	wypiszListe(li, "Wstawienie elementw w rodek");

/* Istnieje moliwo zamiany dwch list miejscami. */

	list <int> x;
	int tab2[3] = {50,20,60};	
	x.assign(&tab2[0], &tab2[3]);
	li.swap(x);
	wypiszListe(li, "Zamian list miejscami");

/*	Mona take poaczy dwie, posortoawne listy w jedn. Funckja merge()pobiera referencje do obiektu drugiej listy, i wstawia jej elementy do listy pierwszej w porzdku rosnacym na odpowiednich miejscah: */

	x.sort();
	li.sort();
	li.merge(x);
	wypiszListe(li, "Poczenie list");

/*	merge() docza x do li. x staje sie pust list. 
 *	Aby wstawi elementy z jednej listy do drugiej, bez potrzeby sortowania, naley uy metofu splice().
 *	Jako parametry naley poda pozycje na ktrej maja by wstawione elementy, list, z ktrej elementy bd pobierane, oraz zakres, elementw do wstawienia */
	x.assign(&tab2[0], &tab2[3]);
	iter = li.begin();
	++iter; ++iter;
	li.splice(iter, x, x.begin(), x.end());
	wypiszListe(li, "Wstaienie lementw w rodek listy, bez uprzedniego sortowania");

/*	Aby usun seri elementw, uywam funkcji erase(). Ta funkcja ma dwie przeciaone wersje:
 *		- pierwsza pobiera iterator i usuwa element na ktry on wskazuje,
 *		- druga, ktra pobiera iterator dwa iteratory i usuwa wszstkie lementy miedzy nimi*/

	iter = li.begin();
	++iter; ++iter; // przesuwamy iterator na lement 3
	li.erase(iter, li.end()); // usuwamy elementy od 3 do koca
	wypiszListe(li, "Lista po usuniciu elemetnw od trzeciego");

/*	Na koniec moemy liste wyczyci cakowicie uywaja metody celar() */
	
	li.clear();

/*	Uytkownik otrzymuje take, moliwo psrawdzenia stanu listy, istnienia jakichkolwiek elementw, rozmiaru, maksymalnego moliwego rozmiaru.
 *	Udostpniana jest take metoda resize() pozwalajaca na zmian wielkoci listy. Przyjmuje ona jako paramtary, nowy rozmiar listy i obiekt,
 *	ktry przy rozszeaniu bdzie dodawany. */

	int tab3[10] = {0,1,2,3,4,5,6,7,8,9}; 
	li.assign(&tab3[0], &tab3[10]);
	wypiszListe(li, "Wypenienie listy 10 elementami");

	if(!li.empty()){
		cout << "------------------------------------------------------------------" << endl;
		cout << "Lista nie jest pusta - if(!empyt())" << endl;
		cout << "------------------------------------------------------------------" << endl;
	}
	cout << "------------------------------------------------------------------" << endl;
	cout << "Rozmiar listy: " << (int)li.size() << " Max rozmiar: " << (int)li.max_size() << endl;
	cout << "------------------------------------------------------------------" << endl;
	li.resize(5);
	wypiszListe(li, "Zmniejszenie do 5 elementw");
	li.resize(10, 199);
	wypiszListe(li, "Ponowne zwikszenie do 10");

/*	Oprcz iteratorw, aby uzyska dostp do pocztku i koca listy mona, take uy funkcji front() i back(). */
	cout << "------------------------------------------------------------------" << endl;	
	cout<< "Pierwszy elemetn listy - fornt(): " << li.front() << ". Ostatli element - back(): " << li.back() << endl;
	cout << "------------------------------------------------------------------" << endl;

/*	std::list oferuje take funkcje pozwalajce zmienia kolejno elementw w licie. S nimi sort() i revers(). */

	li.clear();
	int tab4[10] = {13,1,15, 76, 5, 99, 1, 0, 56,7};
	li.assign(&tab4[0], &tab4[10]);
	wypiszListe(li, "Lista nie posortowana ");
	li.sort();
	wypiszListe(li, "Lista posortowana ");
	li.reverse();
	wypiszListe(li, "Lista w odwrotnej kolejnoci");

/*	std::list pozwala na tworzenie list typw wbudowanych jak i zdefiniowanych przez uytkownika, np.:
 *	Operacje takie jak  sort() czy unique() wykonywane na typach zdefiniowanych przez uytkownika,
 *	wymagaj przecienia operatora <. */
	cout << endl << endl << endl;
	cout << "********************************************************************" << endl;
	cout << "*  Przykad operaji na liscie typu zdefiniowanego przez uytownika *" << endl;
	cout << "********************************************************************" << endl << endl << endl;

	list<Testowa> listTest;
	list<Testowa> listTest2;

	listTest2.push_back(Testowa(5, string("element - lista2 5")));
	listTest2.push_back(Testowa(6, string("element - lista2 6")));
	listTest2.push_back(Testowa(7, string("element - lista2 7")));
	listTest2.push_back(Testowa(8, string("element - lista2 8")));

	listTest.push_back(Testowa(1, string("element 1")));
	listTest.push_back(Testowa(2, string("element 2")));
	listTest.push_back(Testowa(3, string("element 3")));
	listTest.push_back(Testowa(4, string("element 4")));


	wypiszListe( listTest, "Zawartosc listy");

	listTest.push_front(Testowa(5, string("element 5")));
	wypiszListe( listTest, "Dodanie elementu z przodu listy");

	wypiszListe(listTest, "Lista 1");
	wypiszListe(listTest2, "Lista 2");

	listTest.swap(listTest2);
	wypiszListe(listTest, "Zamiana list");

	list<Testowa>::const_iterator it = listTest.begin();
	++it; ++it;
	listTest.splice(it, listTest2);
	wypiszListe( listTest, "Wstawienie listy 2 od 3 miejsca do listy pierwszej");

	listTest.sort();
	wypiszListe( listTest, "Sortowanie listy");

	listTest.reverse();
	wypiszListe( listTest, "Odwrcenie kolejnoci");
	cout << "------------------------------------------------------------------" << endl;
	cout << "Wypisanie listy w odwrotnej kolejnosci przu uzyciu rbegin i rend" << endl;
	cout << "------------------------------------------------------------------" << endl;
	list<Testowa>::reverse_iterator rit;
	for(rit = listTest.rbegin(); rit != listTest.rend(); ++rit){
	 cout << *rit << endl; 
	} 

	listTest.pop_back();
	wypiszListe( listTest, "Usuniecie ostatniego elementu");
	
	it = listTest.begin();
	++it; ++it;
	listTest.erase(it, listTest.end());
	wypiszListe(listTest, "Usunicie elementw od 3 do koca");

	return 0;
}
